<?php
/**
 * Created by PhpStorm.
 * User: marcel
 * Date: 12.06.17
 * Time: 10:37
 */

class a644_media {
    public static function toPicture(rex_media $media, array $breakpoints = [], $prefix = 'img_', $surround = true, $classes = '', $lightbox = false) {
        if (!is_array($breakpoints)) {
            $breakpoints = [];
        }

        if (!$media->isImage()) {
            return '';
        }

        if($media->getType() == 'image/svg+xml') {
            return '<img '.$classes.' alt="'.$media->getTitle().'" src="'.rex_url::frontendController(['rex_media_type' => 'cacheonly', 'rex_media_file' => $media->getFileName(), 'v'=>$media->getUpdateDate()]).'">';
        }

        if(sizeof($breakpoints) == 0) {
            $breakpoints = [
                'xs'=>'768px',
                'sm'=>'992px',
                'md'=>'1200px'
            ];
        }

        $filename = $media->getFileName();
        $out = $lightbox ? '<a href="'.mm_auto::rewrite($filename, $prefix.'source').'" data-toggle="lightbox">' : '';
        $out .= $surround?'<picture>':'';
        foreach($breakpoints as $key => $maxWidth) {
            $out .= '<source media="(max-width: '.$maxWidth.')" srcset="'.mm_auto::rewrite($filename, $prefix.$key).'">';
        }
        $out .= '<img '.$classes.' alt="'.$media->getTitle().'" src="'.mm_auto::rewrite($filename, $prefix.'source').'">';
        $out .= $surround?'</picture>':'';
		$out .= $lightbox ? '</a>' : '';
        return $out;
    }
    public static function toLink(rex_media $media, $linkAttributes, $imgAttributes = []) {
        if(!array_key_exists('class',$imgAttributes)) {
            $imgAttributes['class'] = 'content';
        }
        return '<a href="'.$media->getUrl().'" '.$linkAttributes.'>'.$media->toImage($imgAttributes).'</a>';
    }
}