<?php
/**
 * Created by PhpStorm.
 * User: markus
 * Date: 07.02.18
 * Time: 13:54
 */

class optimizer extends MM_auto
{

    static $sizes     = ['xs' => 'max-width: 380px', 'sm' => 'max-width: 540px', 'md' => 'max-width: 720px', 'lg' => 'max-width: 960px', 'xl' => 'min-width: 1140px'];

    public static function rimage($filename, $alt, $class = '', $params = '') {
        if(!isset($_COOKIE['PHPSESSID']))
		    header("link: <".self::base_url().$filename.">; rel=preload; as=image;", false);
        return '<img src="'.$filename.'" alt="'.$alt.'"'.($class != '' ? ' class="'.$class.'"' : '').' '.$params.' />';
    }

	public static function image($filename = '', $type = '', $alt = '', $class='', $params='') {
	    if($type == null || '') $type = 'default';

	    $m = rex_media_manager::create($type.'-ico@1x', $filename);
        $m->getCacheFilename();

        $a = new rex_managed_media($filename);
        $mediatype = $a->getFormat();

        $i = rex_media::get($filename);

        $w = 1000;
        $h = 500;
        if($i) {
			$w = $i->getWidth();
			$h = $i->getHeight();
		}

        $erg = 100;
        if($w > $h) $erg = $h / $w * 100;
        if($w < $h) $erg = $w / $h * 100;

		$src = '<div class="optimizedpicture '.$class.'" style="padding-top: '.number_format($erg, 2, '.', '').'%; max-width: '.$w.'px; max-height: '.$h.'px"><picture>'.PHP_EOL;
		$src .= self::imageSrcSet($filename, $type);
		$src .= '<img data-src="'.self::rewrite($filename, $type.'-org').'" alt="'.$alt.'" class="lazyload blur-up"  src="data:image/'.$mediatype.';base64,'.(file_exists($m->getCacheFilename()) ? base64_encode(file_get_contents($m->getCacheFilename())) : '').'" '.$params.'>'.PHP_EOL;
		$src .= '</picture></div>';
		return $src;
	}

	public static function getHashedFile($filename) {
		$string = file_get_contents("resources/dist/assets.json");
		$string = json_decode($string);

		return $string->$filename;
    }

	public static function imageSrcSet($filename, $type) {
		if($type == null || '') $type = 'default';

		$m = rex_media::get($filename);
		$sql = rex_sql::factory();
		$sql->setQuery("Select * from rex_media_manager_plus_breakpoints");

		$sizes = [];
		for($i=0; $i < $sql->getRow(); $i++) {
		    if($sql->getValue('name') != 'ico')
            $sizes[$sql->getValue('name')] = $sql->getValue('mediaquery');
		    $sql->next();
        }

//		$filetypes = ['webp' => 'image/webp', 'jp2' => 'image/jp2', 'jpx' => 'image/jpx', $m->getExtension() => $m->getType()];
		if(!is_object($m))
			return '';

		$filetypes = [$m->getExtension() => $m->getType()];

		$srcset = '';

		if($m->getExtension() == 'png' || $m->getExtension() == 'jpg') {
			unset($filetypes['jp2']);
		}
		foreach($sizes as $size_name => $size) {
			foreach($filetypes as $ft => $ft_type) {
			    if($size === end($sizes)) {
					if(!isset($_COOKIE['PHPSESSID']))
					    header("link: <".self::base_url().self::rewrite($filename, $type.'-'.$size_name.($m->getExtension() == $ft ? '' : '_'.$ft)).">; rel=preload; as=image;", false);
                }
                $x1 = self::base_url().self::rewrite($filename, $type.'-'.$size_name.($m->getExtension() == $ft ? '' : '_'.$ft).'@1x');
			    $x2 = self::base_url().self::rewrite($filename, $type.'-'.$size_name.($m->getExtension() == $ft ? '' : '_'.$ft).'@2x').' 2x';
                $x3 = self::base_url().self::rewrite($filename, $type.'-'.$size_name.($m->getExtension() == $ft ? '' : '_'.$ft).'@3x').' 3x';
				$srcset .= '<source data-srcset="'.$x1.', '.$x2.', '.$x3.'" media="'.$size.'" type="'.$ft_type.'">'.PHP_EOL;
			}
		}

		return $srcset;
	}

	public static function getHeader($content = '', $css = [], $js = []) {
		self::setLang();
		header('Content-Type: text/html; charset=utf-8');
		header( 'Cache-Control: max-age=604800' );
		self::getHead($content, $css, $js);
	}

	public static function setLang() {
		if(!isset($_SESSION['lang'])) {
			$supportedLangs = array();
			foreach(rex_clang::getAll() as $lang) {
				$supportedLangs[$lang->getId()] = $lang->getCode();
			}

			if(isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
				$languages = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);

				$current_clang = rex_clang::getCurrent()->getCode();
				foreach($languages as $lang => $clangid) {
					foreach($supportedLangs as $slang_id => $slang_code) {
						if($slang_code == $clangid) {
							if($slang_code != $current_clang) {
								$_SESSION['lang'] = $slang_id;
								rex_redirect(null, $slang_id);
							}
							break;
						}
					}
				}
			}
			$_SESSION['lang'] = '';
		}
	}

	public static function base_url($withoutfolder = false) {
		return (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != '' ? 'https' : 'http').'://'.$_SERVER['SERVER_NAME'].($_SERVER['SERVER_NAME'] == 'localhost' ? ':20080' : '').($withoutfolder == false ? rex_url::frontend() : '');
    }

	public static function getHead($content, $css = [], $js = []) {
		?>
<!DOCTYPE html>
<html lang="<?php echo rex_clang::getCurrent()->getCode(); ?>" dir="ltr">
<head>
	<meta charset="UTF-8">
	<base href="<?=self::base_url();?>">
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1.0, user-scalable=no, viewport-fit=cover">
	<link rel="alternate" hreflang="x-default" href="<?=self::base_url();?>">
	<link rel="icon" type="image/png" href="resources/img/favicon.png">
	<link rel="icon" type="image/x-icon" href="resources/img/favicon.ico">
<?php
		// Keywords and description
		// Wenn der aktuelle Artikel kein Keyword und Description besitzt, werden die aus dem Startartikel genommen
		if(rex_article::getCurrent()->getValue("art_keywords")) {
			$keywords = rex_article::getCurrent()->getValue("art_keywords");
		} else {
			$home = new rex_article_content(rex_article::getSiteStartArticleId());
			$keywords = $home->getValue('art_keywords');
		}
		echo "\t".'<meta name="keywords" content="' . htmlspecialchars($keywords) . '">' . PHP_EOL;
		$seo = new rex_yrewrite_seo();

		echo "\t".$seo->getTitleTag() . PHP_EOL;
		echo "\t".$seo->getDescriptionTag() . PHP_EOL;
		echo "\t".$seo->getRobotsTag() . PHP_EOL;
		echo "\t".$seo->getCanonicalUrlTag() . PHP_EOL; ?>

	<link rel="icon" type="image/x-icon" href="<?=self::base_url();?>media/<?=mInfo('favicon-ico');?>">
	<link rel="icon" type="image/png" href="<?=self::base_url();?>images/favicon-M/<?=mInfo('favicon-png');?>" sizes="32x32">
    <link rel="icon" type="image/png" href="<?=self::base_url();?>images/favicon-L/<?=mInfo('favicon-png');?>" sizes="96x96">
    <link rel="apple-touch-icon" href="<?=self::base_url();?>images/favicon-XL/<?=mInfo('favicon-png');?>" sizes="180x180">
    <link rel="icon" type="image/svg+xml" href="<?=self::base_url();?>media/<?=mInfo('favicon-svg');?>" sizes="any">
    <meta name="apple-mobile-web-app-capable" content="yes" />
    <meta name="HandheldFriendly" content="True">
    <meta http-equiv="cleartype" content="on">
<?php
		self::getAlternateTags().PHP_EOL;
		echo $content.PHP_EOL;

		foreach($css as $cssfile) {
			if(!isset($_COOKIE['PHPSESSID']))
			    header("link: <".self::base_url().$cssfile.">; rel=preload; as=style;", false);
			echo PHP_EOL.'<link rel="stylesheet" href="'.self::base_url().$cssfile.'" defer>';
        }
        foreach($js as $jsfile => $zusatz) {
			if(!isset($_COOKIE['PHPSESSID']))
			    header("link: <".self::base_url().$jsfile.">; rel=preload; as=script;", false);
			echo PHP_EOL.'<script content-type="text/javascript" src="'.$jsfile.'" '.$zusatz.' defer></script>';
        }
		?>
	</head>
<?php
	}

	public static function getAlternateTags() {
		$a = rex_clang::getAll();
		foreach($a as $b) {
			if($b->getId() != rex_clang::getCurrentId() && $b->isOnline()) {
				echo "\t".'<link rel="alternate" hreflang="'.$b->getCode().'" href="'.self::base_url(true).rex_article::getCurrent($b->getId())->getUrl().'" type="text/html" />'.PHP_EOL;
			}
		}
	}
}

