<?php
/**
 * Created by PhpStorm.
 * User: markus
 * Date: 27.03.19
 * Time: 13:54
 */

class rex_flexslider {

	public static function outputscripts($ep) {
		$content = $ep->getSubject();

		if(self::isOnline()) {
			$script = 'function initFlexsliderTeaser() {
							$(".flexslider").flexslider({
								animation: "'.rex_flexslider_config::get('flexslider-animate').'",
								easing: "'.rex_flexslider_config::get('flexslider-easing').'",
								direction: "'.rex_flexslider_config::get('flexslider-direction').'",
								reverse: '.(intval(rex_flexslider_config::get('flexslider-reverse')) == 1 ? "true" : "false").',
								animationLoop: '.(intval(rex_flexslider_config::get('flexslider-loop')) == 1 ? "true" : "false").',
								slideshow: '.(intval(rex_flexslider_config::get('flexslider-slideshow')) == 1 ? "true" : "false").',
								slideshowSpeed: '.intval(rex_flexslider_config::get('flexslider-slideshow-speed')).',
								animationSpeed: '.intval(rex_flexslider_config::get('flexslider-animation-speed')).',
								directionNav: '.(intval(rex_flexslider_config::get('flexslider-control-direction')) == 1 ? "true" : "false").',
								controlNav: '.(intval(rex_flexslider_config::get('flexslider-control-nav')) == 1 ? "true" : "false").',
								directionNav: '.(intval(rex_flexslider_config::get('flexslider-control-direction')) == 1 ? "true" : "false").',
								prevText: "<i class=\'fas fa-angle-left\'></i>'.(rex_flexslider_config::get('flexslider-control-prev-text')).'",
								nextText: "'.(rex_flexslider_config::get('flexslider-control-next-text')).'<i class=\'fas fa-angle-right\'></i>",
								controlsContainer: $(".flexslider__nav"),
								manualControls: ".flex-control-manual-menu",
								touch: true,
								start: function () {
									$embedResponsive.removeClass("loading");
								},
							});
						}';
			$scripts = PHP_EOL . '<script content-type="text/javascript">'.$script.'</script>' . PHP_EOL . '</head>';
			$content = str_replace('</head>', $scripts, $content);
		}
		$ep->setSubject($content);
	}

	public static function getTemplate($templateids, $old = []) {
		$erg = [];
		$erg = array_merge($old, $erg);

		$cfg = self::getConfigArray(true);
		print_r($cfg);
		foreach($templateids as $templateid) {
			if(isset($cfg[$templateid])) {
				$template = self::getCleanTemplate($templateid);

				$vars = self::getRexVarArray($template);
				$templateids2 = self::getEachTemplate($vars);
				if(is_array($templateids2) && sizeof($templateids2) > 0) $erg = self::getTemplate($templateids2, $erg);

				ob_get_clean();
				ob_start();
				$a2 = new rex_article_content();
				$a2->setArticleId(rex_article::getCurrent());
				echo rex_var_template::getTemplateOutput(require rex_var_template::getTemplateStream($templateid, $a2));
				$content = ob_get_contents();
				ob_get_clean();
				$id = rex_onepager_config::get($cfg[$templateid].'_id');
				$erg['TEMPLATE_' . $templateid] = ['id' => $id, 'content' => $content];
			}
		}
		return $erg;
	}

	public static function getConfigArray($getOnlyTemplateIds = false) {
		$sql = rex_sql::factory();
		$sql->setQuery('Select * from '.rex::getTablePrefix().'config where namespace="cachehelper/onepager"'.($getOnlyTemplateIds == true ? ' and `key` like "template_%" and `key` not like "template_%_id"' : ''));

		$erg = [];
		for($i = 0; $i <= $sql->getRows(); $i++) {
			$a = str_replace('"', '', $sql->getValue('value'));
			$erg[$a] = $sql->getValue('key');
			$sql->next();
		}
		return $erg;
	}

	public static function getCleanTemplate($templateid) {
		$sql = rex_sql::factory();
		$qry = 'SELECT content FROM ' . rex::getTablePrefix()  . 'template WHERE id = ' . $templateid;
		$sql->setQuery($qry);

		if ($sql->getRows() == 1) {
			return $sql->getValue('content');
		}
		return false;
	}

	public static function getRexVarArray($content) {
		preg_match_all('/(REX_[A-Z_]+)\[((?:[^\[\]]|\\\\[\[\]]|(?R))*)(?<!\\\\)\]/s', $content, $matches, PREG_SET_ORDER);
		return $matches;
	}

	public static function getEachTemplate($matches) {
		$erg = array();
		foreach($matches as $id => $arr) {
			if(isset($arr[1]) && $arr[1] == 'REX_TEMPLATE') {
				$erg[] = $arr[2];
			}
		}
		return $erg;
	}

	public static function isOnline($clang = null, $default = null) {
		if($clang == null) $clang = rex_clang::getCurrent()->getCode();

		$key = 'onepager-on';
		$value = rex_onepager_config::get($key, $default);
		return ($value == '1' ? true : false);
	}

	public static function cfg($key, $format = null, $default = '', $clang = null) {
		if($clang == null) $clang = rex_clang::getCurrent()->getCode();

		$key = $clang.'_'.$key;
		$value = rex_onepager_config::get($key, $default);
		if($format) {
			if($format === 'phone') {
				return 'tel:'.preg_replace('( |\(0\)|\(|\)|-)', '', $value);
			} elseif($format === 'link') {
				return rex_getUrl($value);
			}
		} else {
			return $value;
		}
	}
}