<?php
/**
 * Created by PhpStorm.
 * User: marcel
 * Date: 06.06.17
 * Time: 15:11
 */

class rex_flexslider_config {
	/** @var  rex_plugin */
	protected static $addon = 'flexslider';
	protected static $plugin = 'flexslider';
	private static $instance;
	private static $inputConfig;

	public static function get($key, $default = '') {
		return self::getInstance()->getConfig($key, $default);
	}


	private static function getInstance() {
		if(!self::$instance) {
			self::$instance = rex_plugin::get('cachehelper', 'flexslider');
		}

		return self::$instance;
	}

	public static function getInputConfig($configfile = 'flexslider.yml') {
		if(!self::$inputConfig) {
			self::$inputConfig = rex_file::getConfig(self::getInstance()->getDataPath($configfile));
		}
		return self::$inputConfig;
	}

	public static function getInput($data, $input, $prefix) {
		$addon = rex_plugin::get('cachehelper', 'flexslider');

		/** @var rex_input element */
		if(isset($data['type']) && $data['type'] == 'link') {
			$element = new rex_input_linkbutton();
			$element->setButtonId($data['id']);
		} elseif(isset($data['type']) && $data['type'] == 'media') {
			$element = new rex_input_mediabutton();
			$element->setButtonId($data['id']);
		} elseif(isset($data['type']) && $data['type'] == 'linklist') {
			$element = new rex_input_linklistbutton();
			$element->setButtonId($data['id']);
		} elseif(isset($data['type']) && $data['type'] == 'medialist') {
			$element = new rex_input_medialistbutton();
			$element->setButtonId($data['id']);
		} elseif(isset($data['type']) && $data['type'] == 'textarea') {
			$element = new rex_input_textarea();
		} elseif(isset($data['type']) && $data['type'] == 'template') {
			$element = new rex_input_select();
			$a = $element->getSelect();
			$a->addOption('- nicht zugeordnet -', '');
			$sql = rex_sql::factory();
			$sql->setQuery("Select name, id from " . rex::getTablePrefix() . "template order by name");

			for($i=0; $i < $sql->getRows(); $i++) {
				$a->addOption($sql->getValue('name'), $sql->getValue('id'));
				$sql->next();
			}

			$a->setSelected($addon->getConfig($input));

			$element = $a;
		} elseif(isset($data['type']) && $data['type'] == 'checkbox') {
			$element = new rex_input_text();
			$element->setAttribute('type', 'checkbox');
			echo $addon->getConfig('flexslider_de_flexslider-on', '');
			if($addon->getConfig($input, '') == '1') {
				$element->setAttribute('checked', 'true');
			}
		} elseif(isset($data['type']) && $data['type'] == 'select') {
			$element = new rex_input_select();
			$a = $element->getSelect();
			if(isset($data['choose']))
				$a->addOption('- nicht zugeordnet -', '');

			if(isset($data['data']))
			foreach($data['data'] as $key => $val) {
				$a->addOption($val, $key);
			}

			$a->setSelected($addon->getConfig($input));
			$element = $a;
		} else {
			$element = new rex_input_text();
			if(isset($data['type']) && $data['type'] != '') {
				$element->setAttribute('type', $data['type']);
			}
		}

		if(isset($data['type']) == false || ($data['type'] != 'template' && $data['type'] != 'select' )) {
			if(isset($data['type']) != false && $data['type'] == 'checkbox') {
				$element->setValue('1');
				$addon->getConfig($input, '');
			} else {
				$element->setValue($addon->getConfig($input));
			}
		}



		$element->setAttribute('name',$prefix.$input);
		$element->setAttribute('id',$prefix.$input);
		$element->setAttribute('class','form-control');

		return (isset($data['type']) && ($data['type'] == 'template' || $data['type'] == 'select') ? $element->get() : $element->getHtml());
	}

	public static function i18n()
	{
		$output = '';

		$args = func_get_args();
		if(!empty($args[0]))
		{
			$string = $args[0];
			$string = preg_replace('/^' . static::$addon . '_/', '', $string);

			$checkfor = [];
			if(!empty(static::$plugin))
			{
				$checkfor[] = static::$addon . '_' . $string;
			}
			$checkfor[] = static::$addon . '_' . $string;
			$checkfor[] = $string;

			foreach($checkfor as $checkstr)
			{
				$checkargs = $args;
				$checkargs[0] = $checkstr;
				$translation = call_user_func_array(array(self::getInstance(), 'i18n'), $checkargs);
				if(substr($translation,0,11) != '[translate:')
				{
					return $translation;
				}
				unset($checkargs, $translation);
			}
			unset($checkfor, $checkstr, $string);

			return call_user_func_array(array(self::getInstance(), 'i18n'), $args);
		}

		return '';
	}
}